#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import time
import random
import unittest

sys.path.append('..')
sys.path.append('../thirdparty/ffx')
sys.path.append('../thirdparty/ranking-test-framework')

import FTE


def main():
    try:
        input_format = ('([a-z0-9_\.]+)@([0-9a-z\.]+)\.([a-z\.]{2,6})', 32)
        output_format = (
            '(https?:\/\/)([\da-z\.\-]+)\.([a-z\.]{2,6})([\/\w \.\-]*)*\/?', 64)
        K = '0' * 16
        fpe = FTE.new(K, input_format=input_format,
                      output_format=output_format)
        N = random.randint(0, fpe._input_ranker.getNumWordsInLanguage() - 1)
        X = fpe._input_ranker.unrank(N)
        C = fpe.encrypt(X)
        Y = fpe.decrypt(C)

        print 'input_format=' + str(input_format)
        print 'output_format=' + str(output_format)
        print 'plaintext=' + X
        print 'ciphertext=' + C
    except FTE.OutputDomainTooSmallException:
        print "FTE.OutputDomainTooSmallException"


if __name__ == '__main__':
    main()
