#!/usr/bin/env python

from distutils.core import setup
from distutils.core import Extension

fte_cDFA = Extension('regex_ranker',
                     include_dirs=['src',
                                   'src/luchaupd'],
                     extra_compile_args=['-O3',
                                         '-fPIC',
                                         '-lstdc++',
                                         '-DPYTHON_MODULE'],
                     extra_link_args=['src/luchaupd_wrapper.o',
                                      'src/luchaupd/rank.a',
                                      '-lgmpxx',
                                      '-lgmp',
                                     ],
                     libraries=[
                                'python2.7',
                                'boost_python',
                                ],
                     sources=['src/regex_ranker.cc'])

setup(name='Regex Ranker',
      version='0.1.0',
      ext_modules=[fte_cDFA],
      )
