#!/bin/bash
where=`uname -a |awk '{print $2}'`
if [[ $where == floreasca.cs.wisc.edu ]] ; then
BASE=/scratch/luchaup/myrank/trunc
else
BASE=/home/dl/myrank
fi
BASE=$PWD
if [[ $RANK == "" ]] ; then
    RANK=$BASE/rank
fi
DIR_TEST=$BASE/tmp/TST
DIR_GOLD=$BASE/tmp/GOLD
FILE_REX=$BASE/TEST_REXs
FILE_INPUTS=$BASE/TEST_INPUTS
#CHECKER=valgrind --leak-check=full
#MISC="-zmake_dfa"
#-zclean_dfa

if [ ! -d ${DIR_TEST} ] ; then
    mkdir ${DIR_TEST}
fi

if [ -d ${DIR_TEST} ] ; then
    rm ${DIR_TEST}/*
    cd ${DIR_TEST}
    echo $RANK $MISC -atrex_tests -ztest-rank -zrexExprFile:${FILE_REX} -zrexInputFile:${FILE_INPUTS}
    if $RANK $MISC -atrex_tests -ztest-rank -zrexExprFile:${FILE_REX} -zrexInputFile:${FILE_INPUTS} > LOG ; then
	diff -r -w --ignore-matching-lines='Timer\|->unparse()=' ${DIR_GOLD} ${DIR_TEST} -xLOG -xlog.diff.err 2>&1 | tee log.diff.err
	if [[ ! -s log.diff.err ]] ; then # i.e. if log.diff.err is not empty
	    echo "PASSED"
	else
	    echo "DIFFERENT"
	fi
    else
	echo "$RANK FAILED!"
    fi
else
    echo cannot find TST directory ${DIR_TEST}
fi
