#include "luchaupd_wrapper.h"

dfa_rank::dfa_rank(std::string regex, size_t n)
    : _ranker(rank_dfa_tab_t(regex, n))
{
    _max_len = _ranker.max_achievable_len();
    _ranker.update_matches(_max_len);
    _num_matches = _ranker.num_matches(_max_len);
    _num_states = _ranker._num_states;
    tab = _ranker.tab;
}

std::string dfa_rank::unrank(const MPInt C) {
    std::string str;
    MPInt copy_n = C;
    _ranker.unrank(copy_n, _max_len, str);
    return str;
}

MPInt dfa_rank::rank(const std::string X) {
    MPInt C = 0;
    _ranker.rank(C, X);
    return C;
}


MPInt dfa_rank::getNumWordsInLanguage() {
    return _num_matches;
}


ffa_rank::ffa_rank(std::string regex, size_t n)
    : _ranker(rank_ffa_tab_t(regex, n))
{
    _max_len = _ranker.max_achievable_len();
    _ranker.update_matches(_max_len);
    _num_matches = _ranker.num_matches(_max_len);
    _num_states = _ranker._num_states;
    tab = _ranker.tab;
}

std::string ffa_rank::unrank(const MPInt C) {
    std::string str;
    MPInt copy_n = C;
    _ranker.unrank(copy_n, _max_len, str);
    return str;
}

MPInt ffa_rank::rank(const std::string X) {
    MPInt C = 0;
    _ranker.rank(C, X);
    return C;
}


MPInt ffa_rank::getNumWordsInLanguage() {
    return _num_matches;
}




nfa_rank::nfa_rank(std::string regex, size_t n)
    : _ranker(rank_nfa_tab_t(regex, n))
{
    _max_len = _ranker.max_achievable_len();
    _ranker.update_matches(_max_len);
    _num_matches = _ranker.num_matches(_max_len);
    _num_states = _ranker._num_states;
    tab = _ranker.tab;
}

std::string nfa_rank::unrank(const MPInt C) {
    std::string str;
    MPInt copy_n = C;
    _ranker.unrank(copy_n, _max_len, str);
    return str;
}

MPInt nfa_rank::rank(const std::string X) {
    MPInt C = 0;
    _ranker.rank(C, X);
    return C;
}


MPInt nfa_rank::getNumWordsInLanguage() {
    return _num_matches;
}
