#include "rankerobject.h"
#include "ranker.h"
#include "ffa.h"

class dfa_rank : public rankerobject {

private:
    rank_dfa_tab_t _ranker;
    size_t _max_len;
    MPInt _num_matches;
public:
    dfa_rank(std::string, size_t);
    ~dfa_rank() {};
    std::string unrank(const MPInt);
    MPInt rank(const std::string);
    MPInt getNumWordsInLanguage();
};

class ffa_rank : public rankerobject {

private:
    rank_ffa_tab_t _ranker;
    size_t _max_len;
    MPInt _num_matches;
public:
    ffa_rank(std::string, size_t);
    ~ffa_rank() {};
    std::string unrank(const MPInt);
    MPInt rank(const std::string);
    MPInt getNumWordsInLanguage();
};



class nfa_rank : public rankerobject {

private:
    rank_nfa_tab_t _ranker;
    size_t _max_len;
    MPInt _num_matches;
public:
    nfa_rank(std::string, size_t);
    ~nfa_rank() {};
    std::string unrank(const MPInt);
    MPInt rank(const std::string);
    MPInt getNumWordsInLanguage();
};

