#include "performance_benchmark_math.h"

#include <algorithm>
#include <assert.h>
#include <chrono>

double mean( const std::vector<double> results ) {
    assert(results.size()>0);

    double retval = 0;
    double sum = 0;
    size_t i = 0;
    for (i=0; i<results.size(); i++) {
        sum += results[i];
    }
    retval = sum / results.size();
    return retval;
}

uint32_t mean( const std::vector<uint32_t> results ) {
    assert(results.size()>0);

    uint32_t retval = 0;
    mpz_class sum = 0;
    size_t i = 0;
    for (i=0; i<results.size(); i++) {
        sum += results[i];
    }
    mpz_class mpzRetval = sum / results.size();
    retval = mpzRetval.get_ui();
    return retval;
}

double median( const std::vector<double> results ) {
    assert(results.size()>0);

    std::vector<double> results_copy = results;
    std::sort (results_copy.begin(), results_copy.begin());
    size_t median_index = results_copy.size()/2;
    double retval = results_copy[median_index];

    return retval;
}

double min( const std::vector<double> results ) {
    assert(results.size()>0);

    double retval = results[0];
    size_t i = 0;
    for (i=1; i<results.size(); i++) {
        if (results[i]<retval) {
            retval = results[i];
        }
    }
    return retval;
}

double max( const std::vector<double> results ) {
    assert(results.size()>0);

    double retval = results[0];
    size_t i = 0;
    for (i=1; i<results.size(); i++) {
        if (results[i]>retval) {
            retval = results[i];
        }
    }
    return retval;
}

mpz_class random_integer(mpz_class n) {
    mpz_class retval;

    auto now = std::chrono::high_resolution_clock::now();
    auto nanos = std::chrono::duration_cast<std::chrono::nanoseconds>(now.time_since_epoch()).count();
    uint32_t seed = nanos;

    gmp_randstate_t california;
    gmp_randinit_default(california);
    gmp_randseed_ui (california, seed);
    mpz_urandomm (retval.get_mpz_t(), california, n.get_mpz_t());

    return retval;
}
