#include "performance_benchmark_mem.h"

#include <sys/time.h>
#include <sys/resource.h>

performance_benchmark_mem::performance_benchmark_mem()
: _baseline(0)
{
    _baseline = getCurrentMemUsage();
}

uint32_t performance_benchmark_mem::getCurrentMemUsage() {
    uint32_t retval = 0;
    
    struct rusage usage;
    getrusage(RUSAGE_SELF, &usage);
    retval = usage.ru_maxrss;

    return retval;
}

uint32_t performance_benchmark_mem::consumed() {
    uint32_t retval = getCurrentMemUsage() - _baseline;
    return retval;
}
